<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | phpBBBridge Plugin for Geeklog - The Ultimate Weblog                      |
// +---------------------------------------------------------------------------+
// | install.php                                                               |
// |                                                                           |
// | This file installs and removes the data structures for the phpBBBridge    |
// | plugin for Geeklog.                                                       |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004-2005 by the following authors:                         |
// |                                                                           |
// | Turias - http://demo.turias.net/                                          |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

$FILE_VERSION = 110;

$paction = $_POST['paction'];
if (!isset($paction))
{
    $paction = "";
}

require_once('../../../lib-common.php');


$result = DB_query("SELECT * FROM " . $_TABLES['plugins'] . " WHERE pi_name='phpbbbridge'");
$nrows = DB_numRows($result);
if ($nrows == 0)
{
    define('PHPBBBRIDGE_DISABLED', true);
}
else
{
    $A = DB_fetchArray($result);

    if ($A['pi_enabled'] == 0)
    {
        define('PHPBBBRIDGE_DISABLED', true);
    }
}

$langfile = $_CONF['path'] . 'plugins/phpbbbridge/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile))
{
    require_once ($langfile);
}
else
{
    require_once ($_CONF['path'] . 'plugins/phpbbbridge/language/english.php');
}

require_once($_CONF['path'] . 'plugins/phpbbbridge/config.php');
require_once($_CONF['path'] . 'plugins/phpbbbridge/functions.inc');

// Only let Root users access this page
if (!SEC_inGroup('Root'))
{
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the phpBBBridge install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_PHPBBB['access_denied']);
    $display .= $LANG_PHPBBB['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
    exit;
}

if ($FILE_VERSION != $_PHPBBB_CONF['version'])
{
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_PHPBBB['error']);
    $display .= $LANG_PHPBBB['file_version_error'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
    exit;
}

/**
* Puts the datastructures for this plugin into the Geeklog database
*
*/
function plugin_install_phpbbbridge()
{
    global $db, $_TABLES, $board_config;

    COM_errorLog('Attempting to install the phpBBBridge plugin.', 1);

    // Get all Geeklog users
    $sql = "SELECT * FROM {$_TABLES['users']} u, {$_TABLES['userprefs']} p, {$_TABLES['userinfo']} i WHERE u.uid = p.uid AND u.uid = i.uid AND u.uid > 1 ORDER BY u.uid ASC";
    $glUsersResult = DB_query($sql);
    $numUsers = DB_numRows($glUsersResult);

    // Update the Admin user
    $A = DB_fetchArray($glUsersResult);
    $regdate = $A['regdate'];
    $regyear = substr($regdate, 0, 4);
    $regmonth = substr($regdate, 5, 7);
    $regday = substr($regdate, 8, 10);
    $reghour = substr($regdate, 11, 13);
    $regminute = substr($regdate, 14, 16);
    $regsecond = substr($regdate, 17);
    $newreg = mktime($reghour, $regminute, $regsecond, $regmonth, $regday, $regyear);

    COM_errorLog('Attempting to update admin phpBB user with admin geeklog user info.', 1);

    $sql = "UPDATE " . USERS_TABLE . " SET"
        . " username = '" . str_replace("'", "''", $A['username']) . "',"
        . " user_password = '" . $A['passwd'] . "',"
        . " user_regdate = " . $newreg . ","
        . " user_level = 1,"
        . " user_email = '" . $A['email'] . "',"
        . " user_website = '" . str_replace("'", "''", $A['homepage']) . "',"
	. " user_from = '" . str_replace("'", "''", $A['location']) . "',"
        . " user_avatar_type = 0,"
        . " user_avatar = '',"
        . " user_viewemail = 0,"
        . " user_allow_viewonline = " . $A['showonline']
        . " WHERE user_id = 2";

    if (!($result = $db->sql_query($sql)))
    {
        COM_errorLog('...failed.', 1);
        message_die(CRITICAL_ERROR, "Could not update admin user", "", __LINE__, __FILE__, $sql);
    }
    COM_errorLog('...success', 1);


    COM_errorLog('Attempting to populate phpBB users table with Geeklog users.', 1);

    // Add the remaining users
    for ($i = 1; $i < $numUsers; $i++)
    {
        $A = DB_fetchArray($glUsersResult);

        $regdate = $A['regdate'];
        $regyear = substr($regdate, 0, 4);
        $regmonth = substr($regdate, 5, 7);
        $regday = substr($regdate, 8, 10);
        $reghour = substr($regdate, 11, 13);
        $regminute = substr($regdate, 14, 16);
        $regsecond = substr($regdate, 17);
        $newreg = mktime($reghour, $regminute, $regsecond, $regmonth, $regday, $regyear);
        $userlevel = 0;
        if (SEC_inGroup('Root', $A['uid']))
        {
            $userlevel = 1;
        }

        // Add the new user to the phpbb database
	$sql = "INSERT into " . USERS_TABLE
	    . " (user_id, username, user_regdate, user_password, user_email, user_icq, user_website,"
            . " user_occ, user_from, user_interests, user_sig, user_sig_bbcode_uid, user_avatar,"
            . " user_avatar_type, user_viewemail, user_aim, user_yim, user_msnm, user_attachsig,"
            . " user_allowsmile, user_allowhtml, user_allowbbcode, user_allow_viewonline,"
            . " user_notify, user_notify_pm, user_popup_pm, user_timezone, user_dateformat,"
            . " user_lang, user_style, user_level, user_allow_pm, user_active, user_actkey) VALUES ("
            . $A['uid'] . ","
            . " '" . str_replace("'", "''", $A['username']) . "',"
            . " " . $newreg . ","
            . " '" . $A['passwd'] . "',"
	    . " '" . $A['email'] . "',"
            . " '',"
            . " '" . str_replace("'", "''", $A['homepage']) . "',"
            . " '', "
	    . " '" . str_replace("'", "''", $A['location']) . "',"
	    . " '', '', '', '', 0, 0, '', '', '',"
            . " " . $board_config['allow_sig'] . ","
            . " " . $board_config['allow_smilies'] . ","
            . " " . $board_config['allow_html'] . ","
            . " " . $board_config['allow_bbcode'] . ","
            . " " . $A['showonline'] . ","
            . " 0, 0, 1,"
            . " '" . $board_config['board_timezone'] . "',"
            . " '" . $board_config['default_dateformat'] . "',"
            . " '" . $board_config['default_lang'] . "',"
            . " " . $board_config['default_style'] . ","
            . " " . $userlevel . ","
            . " 1,"
            . " 1,"
            . " '')";

        if (!($result = $db->sql_query($sql)))
        {
            COM_errorLog('...failed.', 1);
            message_die(CRITICAL_ERROR, "Could not add user", "", __LINE__, __FILE__, $sql);
	}

        $sql = "INSERT INTO " . GROUPS_TABLE . " (group_name, group_description, group_single_user, group_moderator) "
             . "VALUES ('', 'Personal User', 1, 0)";
        if (!($result = $db->sql_query($sql)))
	{
            COM_errorLog('...failed.', 1);
            message_die(CRITICAL_ERROR, "Could not add user", "", __LINE__, __FILE__, $sql);
	}

	$group_id = $db->sql_nextid();
	$user_id = $A['uid'];

        $sql = "INSERT INTO " . USER_GROUP_TABLE . " (user_id, group_id, user_pending)
                VALUES ($user_id, $group_id, 0)";

        if (!($result = $db->sql_query($sql)))
        {
            COM_errorLog('...failed.', 1);
            message_die(CRITICAL_ERROR, "Could not add user", "", __LINE__, __FILE__, $sql);
        }
    }
    COM_errorLog('...success', 1);

    COM_errorLog("Attempting to add recent posts block to Geeklog blocks table...",1);

    $sql = "INSERT INTO " . $_TABLES['blocks'] . "(is_enabled,name,type,title,tid,blockorder,onleft,phpblockfn,group_id,owner_id,perm_owner,perm_group,perm_members,perm_anon) VALUES ('1','latestphpbbposts','phpblock','Latest Forum Posts','all',0,0,'phpblock_phpbbbridge_newtopics',2,2,3,3,2,2)";
    DB_query($sql,1);
    if (DB_error())
    {
        COM_errorLog("...failed",1);
        return false;
    }
    COM_errorLog("...success",1);


    return true;
}

function plugin_register_phpbbbridge()
{
    global $_TABLES, $_PHPBBB_CONF, $db;

    COM_errorLog('Registering phpBBBridge plugin with Geeklog', 1);
    DB_delete($_TABLES['plugins'], 'pi_name', 'phpbbbridge');
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('phpbbbridge', '{$_PHPBBB_CONF['version']}', '1.3.10', 'http://demo.turias.net/', 1)");

    if (DB_error())
    {
        COM_errorLog('...failed', 1);
        return false;
    }
    COM_errorLog('...success', 1);

    return true;
}

function plugin_upgrade_phpbbbridge($curVersion)
{
    global $_TABLES, $_PHPBBB_CONF;

    COM_errorLog('Upgrading the phpBBBridge plugin');

    if ($curVersion == $_PHPBBB_CONF['version'])
    {
        COM_errorLog('...failed. Already up-to-date.', 1);
        return false;
    }

    if ($curVersion <= 0.80)
    {
        COM_errorLog("Attempting to add recent posts block to Geeklog blocks table...",1);

	$sql = "INSERT INTO " . $_TABLES['blocks'] . "(is_enabled,name,type,title,tid,blockorder,onleft,phpblockfn,group_id,owner_id,perm_owner,perm_group,perm_members,perm_anon) VALUES ('1','latestphpbbposts','phpblock','Latest Forum Posts','all',0,0,'phpblock_phpbbbridge_newtopics',2,2,3,3,2,2)";
        DB_query($sql,1);
        if (DB_error())
	{
            COM_errorLog("...failed",1);
	    return false;
        }
        COM_errorLog("...success",1);
    }

    $sql = "UPDATE " . $_TABLES['plugins'] . " SET pi_version='" . $_PHPBBB_CONF['version'] . "' WHERE pi_name='phpbbbridge'";
    $result = DB_query($sql);
    if ($result)
    {
        return true;
    }
    else
    {
        return false;
    }
}

function import_geeklog_forum()
{
    global $_TABLES, $db, $phpbb_root_path, $phpEx, $html_entities_match, $html_entities_replace;
    global $unhtml_specialchars_match, $unhtml_specialchars_replace;

    require_once($phpbb_root_path . 'includes/functions_validate.'.$phpEx);
    require_once($phpbb_root_path . 'includes/bbcode.'.$phpEx);
    require_once($phpbb_root_path . 'includes/functions_post.'.$phpEx);

    COM_errorLog("Exporting Geeklog Forum Categories to phpBB", 1);


    COM_errorLog("Truncating existing phpBB tables", 1);
    $tables = array(TOPICS_WATCH_TABLE, PRUNE_TABLE, AUTH_ACCESS_TABLE, POSTS_TEXT_TABLE,
                    POSTS_TABLE, VOTE_USERS_TABLE, VOTE_RESULTS_TABLE, VOTE_DESC_TABLE,
                    TOPICS_TABLE, FORUMS_TABLE, CATEGORIES_TABLE);
    foreach ($tables as $tableName)
    {
        $sql = "DELETE FROM " . $tableName;
        if (!($result = $db->sql_query($sql)))
        {
            COM_errorLog("...failed", 1);
            message_die(CRITICAL_ERROR, "Failed", "", __LINE__, __FILE__, $sql);
        }
    }
    COM_errorLog("...success", 1);


    COM_errorLog("Adding Geeklog Categories to phpBB", 1);
    $sql = "SELECT * FROM " . $_TABLES['gf_categories'];
    $glResult = DB_query($sql);
    $numRows = DB_numRows($glResult);
    for ($i = 0; $i < $numRows; $i++)
    {
        $A = DB_fetchArray($glResult);
        $sql = "INSERT INTO " . CATEGORIES_TABLE . " (cat_id, cat_title, cat_order) " .
               "VALUES (" . $A['id'] . ", '" . $A['cat_name'] . "', " . $A['cat_order'] . ")";

        if (!($result = $db->sql_query($sql)))
        {
            COM_errorLog("...failed", 1);
            message_die(CRITICAL_ERROR, "Failed", "", __LINE__, __FILE__, $sql);
        }
    }
    COM_errorLog("...success", 1);


    COM_errorLog("Adding Geeklog Forums to phpBB", 1);
    $sql = "SELECT * FROM " . $_TABLES['gf_forums'];
    $glResult = DB_query($sql);
    $numRows = DB_numRows($glResult);
    for ($i = 0; $i < $numRows; $i++)
    {
        $A = DB_fetchArray($glResult);

        $posts = DB_count($_TABLES['gf_topic'], 'forum', $A['forum_id']);
        $topics = DB_count($_TABLES['gf_topic'], array('forum', 'pid'), array($A['forum_id'], 0));

        $sql = "SELECT MAX(id) AS last_post FROM " . $_TABLES['gf_topic'] . " WHERE forum=" . $A['forum_id'];
        $glTmpResult = DB_query($sql);
        $B = DB_fetchArray($glTmpResult);
        $lastPost = $B['last_post'];
	$lastPost = ($lastPost) ? $lastPost : 0;

        $sql = "INSERT INTO " . FORUMS_TABLE . " (forum_id, cat_id, forum_name, forum_desc, forum_status, " .
               "forum_order, forum_posts, forum_topics, forum_last_post_id, prune_next, prune_enable, " .
               "auth_view, auth_read, auth_post, auth_reply, auth_edit, auth_delete, auth_sticky, " .
               "auth_announce, auth_vote, auth_pollcreate, auth_attachments) VALUES (" .
               $A['forum_id'] .
               ", " . $A['forum_cat'] .
               ", '" . textToSQL($A['forum_name']) . "'" .
               ", '" . textToSQL($A['forum_dscp']) . "'" .
               ", 0" .
               ", " . $A['forum_order'] .
               ", " . $posts .
               ", " . $topics .
               ", " . $lastPost .
               ", null, 0, 0, 0, 1, 1, 1, 1, 3, 3, 1, 1, 3)";

        if (!($result = $db->sql_query($sql)))
        {
            COM_errorLog("...failed", 1);
            message_die(CRITICAL_ERROR, "Failed", "", __LINE__, __FILE__, $sql);
        }
    }
    COM_errorLog("...success", 1);

    COM_errorLog("Adding Geeklog Posts to phpBB", 1);
    $sql = "SELECT * FROM " . $_TABLES['gf_topic'] . " ORDER BY id ASC";
    $glResult = DB_query($sql);
    $numRows = DB_numRows($glResult);
    $nextTopicNum = 1;

    for ($i = 0; $i < $numRows; $i++)
    {
        $A = DB_fetchArray($glResult);
        $newTopic = ($A['pid'] == 0);

        $uid = $A['uid'];
        $username = '';
        if ($uid == 1)
        {
            $uid = -1;
            $username = $A['name'];
            $username = str_replace("'", "''", $username);
        }

        if ($newTopic)
        {
            $isLocked = ($A['locked'] == 1);
            $status = 0;

            if ($isLocked)
            {
                $status = TOPIC_LOCKED;
            }
            else
            {
                $status = TOPIC_UNLOCKED;
            }

            $sql = "SELECT MAX(id) AS post_id FROM " . $_TABLES['gf_topic'] . " WHERE pid=" . $A['id'];
            $glTmpResult = DB_query($sql);
            $B = DB_fetchArray($glTmpResult);
            $lastPost = $B['post_id'];
            if (!$lastPost)
            {
                $lastPost = $A['id'];
            }

            $sql = "INSERT INTO " . TOPICS_TABLE . " (topic_id, forum_id, topic_title, topic_poster, topic_time, " .
                   "topic_views, topic_replies, topic_status, topic_vote, topic_type, topic_first_post_id, " .
                   "topic_last_post_id, topic_moved_id) VALUES ("
                   . $nextTopicNum
                   . ", " . $A['forum']
                   . ", '" . textToSQL($A['subject']) . "'"
                   . ", " . $uid
                   . ", " . $A['date']
                   . ", " . $A['views']
                   . ", " . $A['replies']
                   . ", " . $status
                   . ", 0, 0"
                   . ", " . $A['id']
                   . ", " . $lastPost
                   . ", 0)";

            $pidToTopic['' . $A['id']] = $nextTopicNum;
            $nextTopicNum++;

            if (!($result = $db->sql_query($sql)))
            {
                COM_errorLog("...failed", 1);
                message_die(CRITICAL_ERROR, "Failed", "", __LINE__, __FILE__, $sql);
            }
        }

        $topicId = 0;
        if ($A['pid'] == 0)
        {
            $topicId = $pidToTopic['' . $A['id']];
        }
        else
        {
            $topicId = $pidToTopic['' . $A['pid']];
        }

	if ($topicId >= 0)
	{
            $sql = "INSERT INTO " . POSTS_TABLE . " (post_id, topic_id, forum_id, poster_id, post_time, poster_ip, " .
                   "post_username, enable_bbcode, enable_html, enable_smilies, enable_sig, " .
                   "post_edit_count) VALUES ("
                   . " " . $A['id']
                   . ", " . $topicId
                   . ", " . $A['forum']
                    . ", " . $uid
                   . ", " . $A['date']
                   . ", '', '" . $username . "', 1, 0, 1, 1, 0)";
            if (!($result = $db->sql_query($sql)))
            {
                COM_errorLog("...failed", 1);
                message_die(CRITICAL_ERROR, "Failed", "", __LINE__, __FILE__, $sql);
            }

            $fullText = $A['comment'];
            $fullText = textToSQL($fullText);
            $fullText = str_replace('<br />','',$fullText);
            $fullText = gf_showcodetags($fullText);
            $fullText = gf_restoresmilies($fullText);
            $bbcode_uid = make_bbcode_uid();

            $pattern = '#\[quote by= (.*?)\]#i';
            $replacement = '[quote=\\"\\1\\"]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

            $pattern = '#<i>#i';
            $replacement = '[i]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

            $pattern = '#</i>#i';
            $replacement = '[/i]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

            $pattern = '#<b>#i';
            $replacement = '[b]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

            $pattern = '#<strong>#i';
            $replacement = '[b]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

	    $pattern = '#</b>#i';
            $replacement = '[/b]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

	    $pattern = '#</strong>#i';
            $replacement = '[/b]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

	    $pattern = '#<a .*href="(\S*)".*>(.*)</a>#i';
            $replacement = '[url=\\1]\\2[/url]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

	    $pattern = '#<a .*href=(\S*).*>(.*)</a>#i';
            $replacement = '[url=\\1]\\2[/url]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

            $pattern = '#<img .*src="(\S*)".*>#i';
            $replacement = '[img]\\1[/img]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

	    $pattern = '#<img .*src=(\S*).*>#i';
            $replacement = '[img]\\1[/img]';
            $fullText = preg_replace($pattern, $replacement, $fullText);

            $message = prepare_message($fullText, rue, true, true, $bbcode_uid);
            $sql = "INSERT INTO " . POSTS_TEXT_TABLE . " (post_id, bbcode_uid, post_subject, post_text) VALUES ("
                   . " " . $A['id']
                   . ", '" . $bbcode_uid . "'"
                   . ", '" . textToSQL($A['subject']) . "'"
                   . ", '" . $message . "')";
            if (!($result = $db->sql_query($sql)))
            {
                COM_errorLog("...failed", 1);
                message_die(CRITICAL_ERROR, "Failed", "", __LINE__, __FILE__, $sql);
            }
        }
    }
    COM_errorLog("...success", 1);


    COM_errorLog("Updating user post counts in phpBB", 1);
    $numPosts = DB_count($_TABLES['gf_topic'], 'uid', 1);
    $sql = "UPDATE " . USERS_TABLE . " SET user_posts=$numPosts WHERE user_id=-1";
    if (!($result = $db->sql_query($sql)))
    {
        COM_errorLog("...failed", 1);
        message_die(CRITICAL_ERROR, "Failed", "", __LINE__, __FILE__, $sql);
    }

    $sql = "SELECT * FROM " . $_TABLES['users'] . " WHERE uid > 1 ORDER BY uid ASC";
    $glResult = DB_query($sql);
    $numRows = DB_numRows($glResult);
    for ($i = 0; $i < $numRows; $i++)
    {
        $A = DB_fetchArray($glResult);
        $numPosts = DB_count($_TABLES['gf_topic'], 'uid', $A['uid']);
        $sql = "UPDATE " . USERS_TABLE . " SET user_posts=" . $numPosts . " WHERE user_id=" . $A['uid'];
        if (!($result = $db->sql_query($sql)))
        {
            COM_errorLog("...failed", 1);
            message_die(CRITICAL_ERROR, "Failed", "", __LINE__, __FILE__, $sql);
        }
    }
    COM_errorLog("...success", 1);

    return true;
}

// Copied from Blaine's Forum Plugin
function gf_restoresmilies($str)
{
    $str = str_replace( "<img align=absmiddle src='images/smilies/biggrin.gif' alt='Big Grin'>", ':D', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/smile.gif' alt='Smile'>", ':)', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/frown.gif' alt='Frown'>", ':(', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/eek.gif' alt='Eek!'>", '8O', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/confused.gif' alt='Confused'>", ':?', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/cool.gif' alt='Cool'>", 'B)', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/lol.gif' alt='Laughing Out Loud'>", ':lol:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/mad.gif' alt='Angry'>", ':x', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/razz.gif' alt='Razz'>", ':P', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/redface.gif' alt='Oops!'>", ':oops:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/surprised.gif' alt='Surprised!'>", ':o', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/cry.gif' alt='Cry'>", ':cry:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/evil.gif' alt='Evil'>", ':evil:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/twisted.gif' alt='Twisted Evil'>", ':twisted:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/rolleyes.gif' alt='Rolling Eyes'>", ':roll:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/wink.gif' alt='Wink'>", ';)', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/exclaim.gif' alt='Exclaimation'>", ':!:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/question.gif' alt='Question'>", ':question:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/idea.gif' alt='Idea'>", ':idea:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/arrow.gif' alt='Arrow'>", ':arrow:', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/neutral.gif' alt='Neutral'>", ':|', $str );
    $str = str_replace( "<img align=absmiddle src='images/smilies/mrgreen.gif' alt='Mr. Green'>", ':mrgreen:', $str );

    return $str;
}

// Copied from Blaine's Forum Plugin
function gf_showcodetags($str) {
    global $_CONF,$_TABLES;
    $offset = 0;
    $str = " " . $str;
    $strlen = strlen($str);
    while ($offset < $strlen ) {
        $start_pos = strpos( strtolower( $str ), '<pre class="forumcode">', $offset );
        if( $start_pos !== FALSE ) {
            $end_pos = strpos( strtolower( $str ), '</pre>',$offset ) + 6;
            $prev_offset = $offset;
            $offset = $end_pos;
        } else {
            $prev_offset = $end_pos;
            $offset = $strlen;
        }
        if( !( $start_pos === false ) AND !( $end_pos === false ))  {
            $orig_pre_string = substr( $str, 0,$start_pos);
            $working_string = substr( $str, $start_pos, $end_pos - $start_pos );
            $formatString = substr($str,$start_pos, 23);
            $working_string = str_replace( $formatString, '', $working_string );
            $working_string = str_replace( '</pre>', '', $working_string );
            $tmpstr = $orig_pre_string . '[code]' . $working_string . '[/code]';
            $offset = strlen($tmpstr);
            $str = $tmpstr . substr($str,$end_pos);
            $strlen = strlen($str);
        }
    }

    // Need to strip off that extra space I added so that I would catch even the code block at the very beginning.
    return substr($str,1);
}

function doResync()
{
    global $_TABLES, $db, $board_config;

    COM_errorLog("Syncing phpBB Users table with the Geeklog Users table.", 1);

    $sql = "SELECT * FROM {$_TABLES['users']} u, {$_TABLES['userprefs']} p, {$_TABLES['userinfo']} i WHERE u.uid = p.uid AND u.uid = i.uid AND u.uid > 1 ORDER BY u.uid ASC";
    $glResult = DB_query($sql);

    $sql = "SELECT * FROM " . USERS_TABLE . " WHERE user_id > 1 ORDER BY user_id ASC";
    if ( !($bbResult = $db->sql_query($sql)) )
    {
        message_die(CRITICAL_ERROR, 'Could not obtain user list', '', __LINE__, __FILE__, $sql);
    }

    $row = $db->sql_fetchrow($bbResult);
    $A = DB_fetchArray($glResult);

    $keepGoing = true;
    while($keepGoing)
    {
        if ($row && $A)
        {
            if ($row['user_id'] == $A['uid'])
            {
                // Update phpBB Info
                $regdate = $A['regdate'];
                $regyear = substr($regdate, 0, 4);
                $regmonth = substr($regdate, 5, 7);
                $regday = substr($regdate, 8, 10);
                $reghour = substr($regdate, 11, 13);
                $regminute = substr($regdate, 14, 16);
                $regsecond = substr($regdate, 17);
                $newreg = mktime($reghour, $regminute, $regsecond, $regmonth, $regday, $regyear);
                $userlevel = 0;
                if (SEC_inGroup('Root', $A['uid']))
                {
                    $userlevel = 1;
                }

                $sql = "UPDATE " . USERS_TABLE . " SET"
                     . " username = '" . str_replace("'", "''", $A['username']) . "',"
                     . " user_password = '" . $A['passwd'] . "',"
                     . " user_regdate = $newreg,"
                     . " user_level = " . $userlevel . ","
                     . " user_email = '" . $A['email'] . "',"
                     . " user_website = '" . str_replace("'", "''", $A['homepage']) . "',"
		     . " user_from = '" . str_replace("'", "''", $A['location']) . "',"
                     . " user_avatar_type = 0,"
                     . " user_avatar = '',"
                     . " user_viewemail = 0,"
                     . " user_allow_viewonline = " . $A['showonline']
                     . " WHERE user_id=" . $A['uid'];
                if (!($result = $db->sql_query($sql)))
                {
                    COM_errorLog('...failed.', 1);
                    message_die(CRITICAL_ERROR, 'Could not update phpBB user info.', '', __LINE__, __FILE__, $sql);
                }

                $row = $db->sql_fetchrow($bbResult);
                $A = DB_fetchArray($glResult);
            }
            else if ($row['user_id'] < $A['uid'])
            {
                // Delete phpBB User
                plugin_user_delete_phpbbbridge($row['user_id']);

                $row = $db->sql_fetchrow($bbResult);
            }
            else
            {
                // Add phpBB User
                $regdate = $A['regdate'];
                $regyear = substr($regdate, 0, 4);
                $regmonth = substr($regdate, 5, 7);
                $regday = substr($regdate, 8, 10);
                $reghour = substr($regdate, 11, 13);
                $regminute = substr($regdate, 14, 16);
                $regsecond = substr($regdate, 17);
                $newreg = mktime($reghour, $regminute, $regsecond, $regmonth, $regday, $regyear);
                $userlevel = 0;
                if (SEC_inGroup('Root', $A['uid']))
                {
                    $userlevel = 1;
                }

                // Add the new user to the phpbb database
        	$sql = "INSERT into " . USERS_TABLE
        	    . " (user_id, username, user_regdate, user_password, user_email, user_icq, user_website,"
                    . " user_occ, user_from, user_interests, user_sig, user_sig_bbcode_uid, user_avatar,"
                    . " user_avatar_type, user_viewemail, user_aim, user_yim, user_msnm, user_attachsig,"
                    . " user_allowsmile, user_allowhtml, user_allowbbcode, user_allow_viewonline,"
                    . " user_notify, user_notify_pm, user_popup_pm, user_timezone, user_dateformat,"
                    . " user_lang, user_style, user_level, user_allow_pm, user_active, user_actkey) VALUES ("
                    . " " . $A['uid'] . ","
                    . " '" . str_replace("'", "''", $A['username']) . "',"
                    . " " . $newreg . ","
                    . " '" . $A['passwd'] . "',"
        	    . " '" . $A['email'] . "',"
                    . " '',"
                    . " '" . str_replace("'", "''", $A['homepage']) . "',"
                    . " '', "
		    . " '" . str_replace("'", "''", $A['location']) . "',"
		    . " '', '', '', '', 0, 0, '', '', '',"
                    . " " . $board_config['allow_sig'] . ","
                    . " " . $board_config['allow_smilies'] . ","
                    . " " . $board_config['allow_html'] . ","
                    . " " . $board_config['allow_bbcode'] . ","
                    . " " . $A['showonline'] . ","
                    . " 0, 0, 1,"
                    . " '" . $board_config['board_timezone'] . "',"
                    . " '" . $board_config['default_dateformat'] . "',"
                    . " '" . $board_config['default_lang'] . "',"
                    . " " . $board_config['default_style'] . ","
                    . " " . $userlevel . ","
                    . " 1,"
                    . " 1,"
                    . " '')";

                if (!($result = $db->sql_query($sql)))
                {
                    COM_errorLog('...failed.', 1);
                    message_die(CRITICAL_ERROR, "Could not insert user", "", __LINE__, __FILE__, $sql);
        	}

                $sql = "INSERT INTO " . GROUPS_TABLE . " (group_name, group_description, group_single_user, group_moderator) "
                     . "VALUES ('', 'Personal User', 1, 0)";
                if (!($result = $db->sql_query($sql)))
        	{
                    COM_errorLog('...failed.', 1);
                    message_die(CRITICAL_ERROR, "Could not insert user", "", __LINE__, __FILE__, $sql);
        	}

        	$group_id = $db->sql_nextid();
        	$user_id = $A['uid'];

                $sql = "INSERT INTO " . USER_GROUP_TABLE . " (user_id, group_id, user_pending)
                        VALUES ($user_id, $group_id, 0)";

                if (!($result = $db->sql_query($sql)))
                {
                    COM_errorLog('...failed.', 1);
                    message_die(CRITICAL_ERROR, "Could not insert user", "", __LINE__, __FILE__, $sql);
                }

                $A = DB_fetchArray($glResult);
            }
        }
        else if ($row)
        {
	    $keepGoing = false;

	    while ($row)
            {
                // Delete phpBB User
                plugin_user_delete_phpbbbridge($row['user_id']);

                $row = $db->sql_fetchrow($bbResult);
            }
        }
        else if ($A)
        {
            $keepGoing = false;

            while ($A)
            {
                // Add phpBB User
                $regdate = $A['regdate'];
                $regyear = substr($regdate, 0, 4);
                $regmonth = substr($regdate, 5, 7);
                $regday = substr($regdate, 8, 10);
                $reghour = substr($regdate, 11, 13);
                $regminute = substr($regdate, 14, 16);
                $regsecond = substr($regdate, 17);
                $newreg = mktime($reghour, $regminute, $regsecond, $regmonth, $regday, $regyear);
                $userlevel = 0;
                if (SEC_inGroup('Root', $A['uid']))
                {
                    $userlevel = 1;
                }

                // Add the new user to the phpbb database
        	$sql = "INSERT into " . USERS_TABLE
        	    . " (user_id, username, user_regdate, user_password, user_email, user_icq, user_website,"
                    . " user_occ, user_from, user_interests, user_sig, user_sig_bbcode_uid, user_avatar,"
                    . " user_avatar_type, user_viewemail, user_aim, user_yim, user_msnm, user_attachsig,"
                    . " user_allowsmile, user_allowhtml, user_allowbbcode, user_allow_viewonline,"
                    . " user_notify, user_notify_pm, user_popup_pm, user_timezone, user_dateformat,"
                    . " user_lang, user_style, user_level, user_allow_pm, user_active, user_actkey) VALUES ("
                    . " " . $A['uid'] . ","
                    . " '" . str_replace("'", "''", $A['username']) . "',"
                    . " " . $newreg . ","
                    . " '" . $A['passwd'] . "',"
        	    . " '" . $A['email'] . "',"
                    . " '',"
                    . " '" . str_replace("'", "''", $A['homepage']) . "',"
                    . " '',"
		    . " '" . str_replace("'", "''", $A['location']) . "',"
		    . " '', '', '', '', 0, 0, '', '', '',"
                    . " " . $board_config['allow_sig'] . ","
                    . " " . $board_config['allow_smilies'] . ","
                    . " " . $board_config['allow_html'] . ","
                    . " " . $board_config['allow_bbcode'] . ","
                    . " " . $A['showonline'] . ","
                    . " 0, 0, 1,"
                    . " '" . $board_config['board_timezone'] . "',"
                    . " '" . $board_config['default_dateformat'] . "',"
                    . " '" . $board_config['default_lang'] . "',"
                    . " " . $board_config['default_style'] . ","
                    . " " . $userlevel . ","
                    . " 1,"
                    . " 1,"
                    . " '')";

                if (!($result = $db->sql_query($sql)))
                {
                    COM_errorLog('...failed.', 1);
                    message_die(CRITICAL_ERROR, "Could not insert user", "", __LINE__, __FILE__, $sql);
        	}

                $sql = "INSERT INTO " . GROUPS_TABLE . " (group_name, group_description, group_single_user, group_moderator) "
                     . "VALUES ('', 'Personal User', 1, 0)";
                if (!($result = $db->sql_query($sql)))
        	{
                    COM_errorLog('...failed.', 1);
                    message_die(CRITICAL_ERROR, "Could not insert user", "", __LINE__, __FILE__, $sql);
        	}

        	$group_id = $db->sql_nextid();
        	$user_id = $A['uid'];

                $sql = "INSERT INTO " . USER_GROUP_TABLE . " (user_id, group_id, user_pending)
                        VALUES ($user_id, $group_id, 0)";

                if (!($result = $db->sql_query($sql)))
                {
                    COM_errorLog('...failed.', 1);
                    message_die(CRITICAL_ERROR, "Could not insert user", "", __LINE__, __FILE__, $sql);
                }

                $A = DB_fetchArray($glResult);
            }
        }
        else
        {
            $keepGoing = false;
        }
    }

    return true;
}

function textToSQL($str)
{
    $str = str_replace("'", "''", $str);
    $str = str_replace("\\", "\\\\", $str);
    return $str;
}


$display = COM_siteHeader();

if ($paction == 'doenable')
{
    $sql = "UPDATE " . $_TABLES['plugins'] . " SET pi_enabled=1 WHERE pi_name='phpbbbridge'";
    $result = DB_query($sql);

    if ($result)
    {
        $display .= COM_startBlock($LANG_PHPBBB['enabling_plugin']) . $LANG_PHPBBB['success'] . COM_endBlock();
    }
    else
    {
        $display .= COM_startBlock($LANG_PHPBBB['enabling_plugin']) . $LANG_PHPBBB['failed'] . COM_endBlock();
    }
}
else if ($paction == 'dodisable')
{
    $sql = "UPDATE " . $_TABLES['plugins'] . " SET pi_enabled=0 WHERE pi_name='phpbbbridge'";
    $result = DB_query($sql);

    if ($result)
    {
        $display .= COM_startBlock($LANG_PHPBBB['disabling_plugin']) . $LANG_PHPBBB['success'] . COM_endBlock();
    }
    else
    {
        $display .= COM_startBlock($LANG_PHPBBB['disabling_plugin']) . $LANG_PHPBBB['failed'] . COM_endBlock();
    }
}

if ($paction == 'douninstall')
{
    plugin_uninstall_phpbbbridge();

    $timestamp = strftime($_CONF['daytime']);
    $display .= COM_startBlock ($MESSAGE[40] . ' - ' . $timestamp)
             . '<p><img src="' . $_CONF['layout_url']
             . '/images/sysmessage.gif" border="0" align="top" alt="">'
             . 'The plugin has been successfully uninstalled.' . '</p>' . COM_endBlock ();
}
else if ($paction == 'doupgrade')
{
    $display .= COM_startBlock($LANG_PHPBBB['upgrading_phpbbb']);
    $result = DB_query("SELECT * FROM " . $_TABLES['plugins'] . " WHERE pi_name='phpbbbridge'");
    $nrows = DB_numRows($result);

    if ($nrows == 0)
    {
        COM_errorLog('Could not upgrade phpBBBridge because it is not installed.');
        $display .= $LANG_PHPBBB['upgrade_failed'];
    }
    else
    {
        $A = DB_fetchArray($result);
        $ver = $A['pi_version'];

        if (plugin_upgrade_phpbbbridge($ver))
        {
            $display .= $LANG_PHPBBB['upgrade_successful'];
        }
        else
        {
            $display .= $LANG_PHPBBB['upgrade_failed'];
        }
    }

    $display .= COM_endBlock();
}
else if ($paction == 'doinstall')
{
    if (DB_count ($_TABLES['plugins'], 'pi_name', 'phpbbbridge') > 0)
    {
        // plugin already installed
        $display .= COM_startBlock ($LANG32[6])
            . '<p>' . $LANG32[7] . '</p>'
            . COM_endBlock ();
    }
    else
    {
        // plugin not installed - do it now
        $result = plugin_install_phpbbbridge();
        if ($result)
        {
            $result = plugin_register_phpbbbridge();
        }

        if ($result)
        {
            COM_errorLog('Succesfully installed the phpBBBridge Plugin!',1);
            $display = COM_refresh ($_CONF['site_admin_url']
                                    . '/plugins.php?msg=44');
        }
        else
        {
            $timestamp = strftime($_CONF['daytime']);
            $display .= COM_startBlock ($MESSAGE[40] . ' - ' . $timestamp)
                     . '<p><img src="' . $_CONF['layout_url']
                     . '/images/sysmessage.gif" border="0" align="top" alt="">'
                     . $LANG08[6] . '</p>' . COM_endBlock ();
        }
    }
}
else if ($paction == 'doimport')
{
    $result = import_geeklog_forum();

    if ($result == true)
    {
        $display .= COM_startBlock($LANG_PHPBBB['importing_geeklog_posts']) . $LANG_PHPBBB['imported_posts_successfully'] . COM_endBlock();
    }
}
else if ($paction == 'doresync')
{
    $result = doResync();

    if ($result == true)
    {
        $display .= COM_startBlock($LANG_PHPBBB['resyncing_user_tables']) . $LANG_PHPBBB['resynced_successfully'] . COM_endBlock();
    }
}
else
{
    $display .= COM_startBlock ($LANG_PHPBBB['admin_heading']);
    $display .= $LANG_PHPBBB['admin_msg'] . '<br /><br />' . $LANG_PHPBBB['plugin_status']
              . '<form method="post" action="' . $_CONF['site_admin_url'] . '/plugins/phpbbbridge/install.php">'
              . '<input type="hidden" name="paction" value="">';

    $result = DB_query("SELECT * FROM " . $_TABLES['plugins'] . " WHERE pi_name='phpbbbridge'");
    $nrows = DB_numRows($result);
    if ($nrows == 0)
    {
        $display .= ' <b>' . $LANG_PHPBBB['uninstalled'] . '</b><br /><br />';
        $display .= '<input type="button" value="' . $LANG_PHPBBB['install'] . '" onclick="this.form.paction.value=\'doinstall\';this.form.submit();">';
    }
    else
    {
        $A = DB_fetchArray($result);
        $display .= ' <b>' . $LANG_PHPBBB['installed'] . '</b>,';

        if ($A['pi_enabled'] == 0)
        {
            $display .= ' <b>' . $LANG_PHPBBB['disabled'] . '</b><br />';
        }
        else
        {
            $display .= ' <b>' . $LANG_PHPBBB['enabled'] . '</b><br />';
        }

        $display .= $LANG_PHPBBB['version_installed'] . ' <b>' . $A['pi_version'] . '</b><br />'
            . $LANG_PHPBBB['version_files'] . ' <b>' . $_PHPBBB_CONF['version'] . '</b><br /><br />';

        if ($A['pi_version'] < $_PHPBBB_CONF['version'])
        {
            $display .= '<input type="button" value="' . $LANG_PHPBBB['upgrade'] . '" onclick="this.form.paction.value=\'doupgrade\';this.form.submit();">';
	    $display .= COM_endBlock() . COM_siteFooter();
	    echo $display;
	    exit;
        }
        else if ($A['pi_version'] > $_PHPBBB_CONF['version'])
        {
            $display .= $LANG_PHPBBB['old_files_warning'] . '<br />';
	    $display .= COM_endBlock() . COM_siteFooter();
	    echo $display;
	    exit;
	}

        $display .= ' <input type="button" value="' . $LANG_PHPBBB['uninstall'] . '" onclick="if(confirm(\'' . $LANG_PHPBBB['uninstall_confirm_msg'] . '\')){this.form.paction.value=\'douninstall\';this.form.submit();}">';

        if ($A['pi_enabled'] == 0)
        {
            $display .= ' <input type="button" value="' . $LANG_PHPBBB['enable'] . '" onclick="this.form.paction.value=\'doenable\';this.form.submit();">';
        }
        else
	{
            $display .= ' <input type="button" value="' . $LANG_PHPBBB['disable'] . '" onclick="this.form.paction.value=\'dodisable\';this.form.submit();">';
	}

        if (DB_count($_TABLES['plugins'], 'pi_name', 'forum') > 0)
        {
            $display .= '<br /><br />' . $LANG_PHPBBB['import_msg'] . '<br />';
            $display .= '<br /><input type="button" value="' . $LANG_PHPBBB['import'] . '" onclick="if(confirm(\'' . $LANG_PHPBBB['import_confirm_msg'] . '\')){this.form.paction.value=\'doimport\';this.form.submit();}">';
        }

        $display .= '<br /><br />' . $LANG_PHPBBB['resync_msg'] . '<br />';
        $display .= '<br /><input type="button" value="' . $LANG_PHPBBB['resync'] . '" onclick="this.form.paction.value=\'doresync\';this.form.submit();">';

        $display .= '</form>';
    }

    $display .= COM_endBlock();
}

$display .= COM_siteFooter();

echo $display;

?>
